/**
 * core.js - all global scripts belong in this file.
 */

// NAMESPACE FOR COMMON FUNCTIONS/OBJECTS
var COMMONUTILS = {
  //
  pageWidth : function() {"use strict";
    return document.documentElement.clientWidth;
  },

  // Create Video Boxes
  videoBox : function() {"use strict";
    $(".video-box").each(function(){
      return false;
    });
  },

  optinFormValidate: function() { "use strict";

    var formName = "";

    $(".subscribe").each(function(i){

      formName = "optin"+i;
      $(this).attr("id",formName);

        //
        $(this).validate({
          rules : {
            email : { required : true, email : true }/*,
            zip : 'required'*/
          },
          messages : {
            email : 'Enter a valid email'/*,
            zip : 'Enter your zip code'*/
          },
          errorPlacement : function(error, element) {
            element.attr('placeholder', error[0].outerText);
          },
          submitHandler : function(form) {
            $.ajax({
              url : './_inc/optin_action.php',
              type : 'POST',
              data : $(form).serialize() + '&ajax=true',
              success : function(text) {
                $(form).hide();
                $(form).parent("div").append('<h3 class="text-center form-thanks">THANK YOU FOR SIGNING UP.<br><span>Check your email to confirm your subscription.</span></h3>');
              }
            });
            return false;
          }
        });

        //console.log(formName + ' set up for validation');

    });
  }

};

/*
  team.js
--------------------------------------------------------------- */

//Namespace for bio functions
var bioGrid = {};

bioGrid.bioindex = 0;
bioGrid.bios = [];

bioGrid.loadBios = function () {"use strict";
  //Cast & Creative Bios
  for (var i=0; i < $("#cast .member").length; i++) {
    bioGrid.bios.push($('#cast .member:nth-child('+ (i+1) +')').clone());
    $('#cast .member:nth-child('+ (i+1) +')').data('index', i);
    //console.log($('#cast .member:nth-child('+ (i+1) +')'));
  }

  for (var i=0; i < $("#creative .member").length; i++) {
    bioGrid.bios.push($('#creative .member:nth-child('+ (i+1) +')').clone());
    $('#creative .member:nth-child('+ (i+1) +')').data('index',(bioGrid.bios.length-1));
    //console.log($('#creative .member:nth-child('+ (i+1) +')'));
  }
  
  setTimeout(() => { $('body').addClass('bio-loaded'); }, 1000);

  $(".team .member").on("click", function(e) {
    e.preventDefault();
    bioGrid.bioindex = $(this).data('index');
    //console.log(bioGrid.bioindex);
    // update content and open overlay
    $("#overlay-inner").html(bioGrid.bios[bioGrid.bioindex]);
    $("html, body").addClass ("overlay-open");
    // next/prev
    $(".overlay .prev, .overlay .next").show();
    if (bioGrid.bioindex == (bioGrid.bios.length - 1)) {
        $(".overlay .next").hide();
    } else if (bioGrid.bioindex == 0) {
        $(".overlay .prev").hide();
    }
  });
};

//Next/Previous navigation
bioGrid.bioNav = function () {
  $(".overlay .next").on('click', function(e) {
    e.preventDefault();
    $(".overlay .prev").show();
    if (bioGrid.bioindex == (bioGrid.bios.length - 2)) {
      $(this).hide();
    }
    else {
      $(this).show();
    }
    bioGrid.bioindex++;
    $("#overlay-inner").fadeOut(300, function() {
      $(this).html(bioGrid.bios[bioGrid.bioindex]).fadeIn(500);
    });
    //console.log(bioGrid.bioindex);
  });

  $(".overlay .prev").on('click', function(e) {
      e.preventDefault();
      $(".overlay .next").show();
      if (bioGrid.bioindex == 1) {
        $(this).hide();
      } else {
        $(this).show();
      }
      bioGrid.bioindex--;
      $("#overlay-inner").fadeOut(300, function() {
          $(this).html(bioGrid.bios[bioGrid.bioindex]).fadeIn(500);
      });
      //console.log(bioGrid.bioindex);
  });
};

// Close Cast Overlay
bioGrid.hideOverlay = function () {
  $ (".overlay .close").click (function (e) {
    e.preventDefault ();
    $ ("html, body").removeClass ("overlay-open");
  });
};


$(document).ready (function () {"use strict";
  $('html').addClass('page-loaded');
  COMMONUTILS.optinFormValidate();

  //Quote Rotator
  $('#quotes').slick({
    slidesToShow: 1,
    slidesToScroll: 1,
    arrows:false,
    autoplay:true,
    autoplaySpeed:3500,
    fade:true
  });

  bioGrid.loadBios();
  bioGrid.bioNav();
  bioGrid.hideOverlay();

  $('#audible-carousel').removeClass("hide-onload").slick({
    slidesToShow: 4,
    slidesToScroll: 1,
    autoplay: true,
    autoplaySpeed: 2000,
    responsive:[
      {
        breakpoint: 767,
        settings: {
          slidesToShow: 3,
          slidesToScroll: 1
        }
      },
      {
        breakpoint: 480,
        settings: {
          slidesToShow: 2,
          slidesToScroll: 1
        }
      }
    ]
  });

  /* CUSTOM THUMBNIAL CLICK */
  // main document must be focused in order for window blur to fire when the iframe is interacted with. 
  // There's still an issue that if user interacts outside of the page and then click iframe first without clicking page, the following logic won't run. But since the OP is only concerned about first click this shouldn't be a problem.
  $('#video.custom-thumb').on("click",function(e){
    e.preventDefault();
    $(this).removeClass('custom-thumb');
    $('#video').html('<iframe width="560" height="315" src="https://www.youtube.com/embed/'+ $(this).data('id') +'?autoplay=1" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>');
  });
  /* END CUSTOM THUMBNIAL CLICK */

});
// EOF